<template>
    <div id="app">
        <div class="content">
            <div class="task-conatiner" id="0">
                <div class="task-title tomato" ><p>On hold</p><p>({{cards_0.length}})</p></div>
                    <div class="add-task">
                    <draggable v-model="cards_0" group="people" @start="drag=true" @end="drag=false" :move="checkMove">
                        <div class="task" v-for="(card,index) in cards_0" :key="card.id">
                            <div class="task-close-btn" @click="deleteCard(card.id,card.row,index)"><img class="close-btn" src="@/assets/icons/delete.svg" alt=""></div>
                            <div class="task-content">
                                <p>id: {{card.id}}</p>
                                <p>{{card.text}}</p>
                            </div>
                        </div>
                        </draggable>
                    <div class="create-task" v-if="addCard_0"> 
                        <div class="task-content">
                            <textarea rows="4" cols="37" v-model="text" placeholder="Ввести заголовок для этой карточке"></textarea>
                        </div>
                    </div>
                    <div class="add-task-button">
                        <div v-if="add_0" class="add">
                            <img class="add-icon" src="@/assets/icons/plus-sign.svg">
                            <p class="add-card" @click="AddCard(0)" >Добавить карточку</p>
                        </div>
                        <div v-if="saveCard_0">
                            <div class="save-card button" @click="SaveCard(0)">Добавить карточку</div>
                            <div class="delete-card" @click="cancelAddCard(0)"><img src="@/assets/icons/delete.svg" width="12px"></div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="task-conatiner" id="1">
                <div class="task-title blue"><p>In progress</p><p>({{cards_1.length}})</p></div>
                <div class="add-task">
                    <draggable v-model="cards_1" group="people" @start="drag=true" @end="drag=false" :move="checkMove">
                        <div class="task" v-for="(card,index) in cards_1" :key="card.id">
                            <div class="task-close-btn"  @click="deleteCard(card.id,card.row,index)" ><img class="close-btn" src="@/assets/icons/delete.svg" alt=""></div>
                            <div class="task-content">
                                <p>id: {{card.id}}</p>
                                <p>{{card.text}}</p>
                            </div>
                            </div>
                    </draggable>
                        <div class="create-task" v-if="addCard_1">
                        <div class="task-content">
                            <textarea rows="4" cols="37" v-model="text" placeholder="Ввести заголовок для этой карточке"></textarea>
                        </div>
                    </div>
                    <div class="add-task-button">
                        <div v-if="add_1" class="add">
                            <img class="add-icon" src="@/assets/icons/plus-sign.svg">
                            <p class="add-card" @click="AddCard(1)" >Добавить карточку</p>
                        </div>
                        <div v-if="saveCard_1">
                            <div class="save-card button" @click="SaveCard(1)">Добавить карточку</div>
                            <div class="delete-card" @click="cancelAddCard(1)"><img src="@/assets/icons/delete.svg" width="12px"></div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="task-conatiner" id="2">
                <div class="task-title yellow"><p>Needs review</p><p>({{cards_2.length}})</p></div>
                <div class="add-task">
                    <draggable v-model="cards_2" group="people" @start="drag=true" @end="drag=false" :move="checkMove">
                        <div class="task" v-for="(card,index) in cards_2" :key="card.id">
                            <div class="task-close-btn"  @click="deleteCard(card.id,card.row,index)" ><img class="close-btn" src="@/assets/icons/delete.svg" alt=""></div>
                            <div class="task-content">
                                <p>id: {{card.id}}</p>
                                <p>{{card.text}}</p>
                            </div>
                        </div>
                    </draggable>
                    <div class="create-task" v-if="addCard_2">
                        <div class="task-content">
                            <textarea rows="4" cols="37"  v-model="text" placeholder="Ввести заголовок для этой карточке"></textarea>
                        </div>
                    </div>
                    <div class="add-task-button">
                        <div v-if="add_2" class="add">
                            <img class="add-icon" src="@/assets/icons/plus-sign.svg">
                            <p class="add-card" @click="AddCard(2)" >Добавить карточку</p>
                        </div>
                        <div v-if="saveCard_2">
                            <div class="save-card button" @click="SaveCard(2)" >Добавить карточку</div>
                            <div class="delete-card" @click="cancelAddCard(2)"><img src="@/assets/icons/delete.svg" width="12px"></div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="task-conatiner" id="3">
                <div class="task-title green"><p>Approved</p><p>({{cards_3.length}})</p></div>
                <div class="add-task">
                    <draggable v-model="cards_3" group="people" @start="drag=true" @end="drag=true" :move="checkMove">
                    <div class="task" v-for="(card,index) in cards_3" :key="card.id">
                        <div class="task-close-btn"  @click="deleteCard(card.id,card.row,index)" ><img class="close-btn" src="@/assets/icons/delete.svg" alt=""></div>
                        <div class="task-content">
                            <p>id: {{card.id}}</p>
                            <p>{{card.text}}</p>
                        </div>
                        </div>
                    </draggable>
                    <div class="create-task" v-if="addCard_3">
                        <div class="task-content">
                            <textarea rows="4" cols="37" v-model="text" placeholder="Ввести заголовок для этой карточке"></textarea>
                        </div>
                    </div>
                    <div class="add-task-button">
                        <div v-if="add_3" class="add">
                            <img class="add-icon" src="@/assets/icons/plus-sign.svg">
                            <p class="add-card" @click="AddCard(3)" >Добавить карточку</p>
                        </div>
                        <div v-if="saveCard_3">
                            <div class="save-card button" @click="SaveCard(3)">Добавить карточку</div>
                            <div class="delete-card" @click="cancelAddCard(3)"><img src="@/assets/icons/delete.svg" width="12px"></div>
                        </div>
                    </div>
                </div>
            </div>
        </div>  
        <router-view></router-view>  
    </div>
</template>

<script>
import { mapState, mapActions } from 'vuex'
import draggable from 'vuedraggable'
import { APIService } from "@/APIService";

const apiService = new APIService();

export default {
    name: 'Home',
    data() {
        return {
            token: null,
            cards: [],

            addCard_0: false,
            addCard_1: false,
            addCard_2: false,
            addCard_3: false,
            add_0: true,
            add_1: true,
            add_2: true,
            add_3: true,
            saveCard_0: false,
            saveCard_1: false,
            saveCard_2: false,
            saveCard_3: false,

            text: null,
           
            cards_0: [],
            cards_1: [],
            cards_2: [],
            cards_3: []
        }
    },
    components: {
            draggable,
        },
    methods: {
        ...mapActions(['getCards', 'refreshToken', 'CreateCard', 'RemoveCard', 'updateCardsLists']),

        AddCard(row_num){

            if(row_num == 0){
                this.addCard_0 = true;
                this.add_0 = false;
                this.saveCard_0 = true
            }
            else if(row_num == 1){
                this.addCard_1 = true;
                this.add_1 = false;
                this.saveCard_1 = true
            }
            else if(row_num == 2){
                this.addCard_2 = true;
                this.add_2 = false;
                this.saveCard_2 = true
            }
            else if(row_num == 3){
                this.addCard_3 = true;
                this.add_3 = false;
                this.saveCard_3 = true
            }
        },

        cancelAddCard(row_num){
            if(row_num == 0){
                this.addCard_0 = false;
                this.saveCard_0 = false;
                this.add_0 = true
            }
            else if(row_num == 1){
                this.addCard_1 = false;
                this.saveCard_1 = false;
                this.add_1 = true
            }
            else if(row_num == 2){
                this.addCard_2 = false;
                this.saveCard_2 = false;
                this.add_2 = true
            }
            else if(row_num == 3){
                this.addCard_3 = false;
                this.saveCard_3 = false;
                this.add_3 = true
            }
        },

        SaveCard(row){
            this.CreateCard({
                text: this.text,
                row: row
            })
            .then(res => {
                if(res.status == 201){
                    this.getCards({
                        token: this.token,
                       })
                         .then(res => {
                            const row = res.data ;
                            this.cards_0 = [];
                            this.cards_1 = [];
                            this.cards_2 = [];
                            this.cards_3 = [];
                            this.text = null;

                            for(let i = 0; i<= row.length; i++){
                                if(row[i].row == 0){
                                    this.cards_0.push(res.data[i])
                                }
                                else if(row[i].row == 1){
                                    this.cards_1.push(res.data[i])
                                }
                                else if(row[i].row == 2){
                                    this.cards_2.push(res.data[i])
                                }
                                else if(row[i].row == 3){
                                    this.cards_3.push(res.data[i])
                                }
                      
                                if(row[i].row == 0){
                                    this.addCard_0 = false;
                                    this.saveCard_0 = false;
                                    this.add_0 = true
                                }
                                else if(row[i].row == 1){
                                    this.addCard_1 = false;
                                    this.saveCard_1 = false;
                                    this.add_1 = true
                                }
                                else if(row[i].row == 2){
                                    this.addCard_2 = false;
                                    this.saveCard_2 = false;
                                    this.add_2 = true
                                }
                                else if(row[i].row == 3){
                                    this.addCard_3 = false;
                                    this.saveCard_3 = false;
                                    this.add_3 = true
                                }
                            }
                        })
                    }
                })
            .catch(err => {
                console.log(err)
            })
        },

        checkMove: function(evt){
            
            const data = evt.draggedContext.element
            this.updateCardsLists({
                id : data.id,
                row : evt.relatedContext.component._uid,
                seq_num : data.seq_num,
                text :  data.text
            })
            .then(res => {
                console.log(res)
            })
            .catch(err => {
                console.log(err)
            })
        },

        deleteCard(id,row,index){
       
            this.RemoveCard({
                id: id
            })
            .then(res => {
                // if(res == 204){
                //    if(row == 0){
                //      this.cards_0.splice(index,1);
                //     }
                //     else if(row == 1){
                //         this.cards_1.splice(index,1);
                //     }
                //     else if(row == 2){
                //         this.cards_2.splice(index,1);
                //     }
                //     else if(row == 3){
                //         this.cards_3.splice(index,1);
                //     }
                 this.getCards({
                        token: this.token,
                    })
                         .then(res => {
                            const row = res.data ;
                            this.cards_0 = [];
                            this.cards_1 = [];
                            this.cards_2 = [];
                            this.cards_3 = [];
                            this.text = null;

                            for(let i = 0; i<= row.length; i++){
                                if(row[i].row == 0){
                                    this.cards_0.push(res.data[i])
                                }
                                else if(row[i].row == 1){
                                    this.cards_1.push(res.data[i])
                                }
                                else if(row[i].row == 2){
                                    this.cards_2.push(res.data[i])
                                }
                                else if(row[i].row == 3){
                                    this.cards_3.push(res.data[i])
                                }
                            }
                        })     
                      })
                .catch(err => {
                    console.log(err)
                })

                }
            },

    created() {
        this.token = JSON.parse(localStorage.getItem("token"));
        this.getCards({
            token: this.token,
        })
       .then(res => {
           const row = res.data ;
           for(let i = 0; i<= row.length; i++){
               this.cards.push(res.data[i]);
               if(row[i].row == 0){
                   this.cards_0.push(res.data[i])
               }
               else if(row[i].row == 1){
                   this.cards_1.push(res.data[i])
               }
               else if(row[i].row == 2){
                   this.cards_2.push(res.data[i])
               }
               else if(row[i].row == 3){
                   this.cards_3.push(res.data[i])
               }
           }
         })
         .catch(err => {
             if(err.response.data.detail == "Signature has expired."){
                //  this.refreshToken({
                //      token: this.token
                //  })
                localStorage.removeItem("token") 
                this.$router.push('/')
               }
            }) 
          },
        }
    </script>

